<template>
  <div />
</template>

<script>
import * as d3 from "d3";

export default {
  name: "StackedAreaChart",

  data() {
    return {
      data: [
        {
          x: "x1",
          s1: 2,
          s2: 10,
          s3: 1,
          s4: 7,
          s5: 3,
        },
        {
          x: "x2",
          s1: 6,
          s2: 3,
          s3: 3,
          s4: 12,
          s5: 9,
        },
        {
          x: "x3",
          s1: 3,
          s2: 9,
          s3: 3,
          s4: 2,
          s5: 8,
        },
      ],
      labels: [],
      width: 100,
      height: 100,

      colorScale: ["#4A148C", "#9652DF", "#B98CEA", "#7319D5", "#DCC5F4"],
    };
  },

  mounted() {
    this.render();
  },

  methods: {
    render() {
      const margin = { top: 20, right: 30, bottom: 30, left: 40 };

      const series = d3.stack().keys(Object.keys(this.data[0]).slice(1))(
        this.data
      );

      const y = d3
        .scaleLinear()
        .domain([0, d3.max(series, (d) => d3.max(d, (d) => d[1]))])
        .nice()
        .range([this.height - margin.bottom, margin.top]);

      const x = d3
        .scaleBand()
        .domain(Object.keys(this.data[0]).slice(1))
        .range([margin.left, this.width - margin.right]);

      let domain = Object.keys(this.data[0]).slice(1);
      console.log(domain, x(domain[0]));

      console.log(d3.extent(this.data, (d) => d.x));

      const yAxis = (g) =>
        g
          .attr("transform", `translate(${margin.left},0)`)
          .call(d3.axisLeft(y))
          .call((g) => g.select(".domain").remove())
          .call((g) =>
            g
              .select(".tick:last-of-type text")
              .clone()
              .attr("x", 3)
              .attr("text-anchor", "start")
              .attr("font-weight", "bold")
              .text(this.data.y)
          );

      const xAxis = (g) =>
        g.attr("transform", `translate(0,${this.height - margin.bottom})`).call(
          d3
            .axisBottom(x)
            .ticks(this.width / 80)
            // .tickFormat((i) => this.data[i].x)
            .tickSizeOuter(0)
        );

      const area = d3
        .area()
        .x((d) => {
          console.log("x", d.data.x);
          // console.log("x", d.data.x, x(d.data.x));
          return x(d.data.x);
        })
        .y0((d) => y(d[0]))
        .y1((d) => y(d[1]));

      const svg = d3
        .select(this.$el)
        .append("svg")
        .attr("viewBox", [0, 0, this.width, this.height])
        .attr("font-size", 10)
        .attr("font-family", "sans-serif")
        .attr("text-anchor", "middle");

      svg
        .append("g")
        .selectAll("path")
        .data(series)
        .join("path")
        .attr("fill", ({ index }) => this.colorScale[index])
        .attr("d", area)
        .append("title")
        .text(({ key }) => key);

      svg.append("g").call(xAxis);

      svg.append("g").call(yAxis);
    },
  },
};
</script>
